'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.CustomGraphiQL = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _graphiql = require('graphiql');

var _graphiql2 = _interopRequireDefault(_graphiql);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _tokenInput = require('./token-input.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomGraphiQL = exports.CustomGraphiQL = function (_Component) {
    _inherits(CustomGraphiQL, _Component);

    _createClass(CustomGraphiQL, null, [{
        key: 'propTypes',
        get: function get() {
            return {
                graphQLEndpoint: _propTypes2.default.string
            };
        }
    }]);

    function CustomGraphiQL(props) {
        _classCallCheck(this, CustomGraphiQL);

        var _this = _possibleConstructorReturn(this, (CustomGraphiQL.__proto__ || Object.getPrototypeOf(CustomGraphiQL)).call(this, props));

        _this.handleTokenInputChange = _this.handleTokenInputChange.bind(_this);
        _this.graphQLFetcher = _this.graphQLFetcher.bind(_this);
        _this.handleEditQuery = _this.handleEditQuery.bind(_this);
        _this.handleEditVariables = _this.handleEditVariables.bind(_this);
        _this.handleEditOperationName = _this.handleEditOperationName.bind(_this);
        _this.updateURL = _this.updateURL.bind(_this);

        // Parse the search string to get url parameters.
        var search = window.location.search;

        var parameters = {};
        search.substr(1).split('&').forEach(function (entry) {
            var eq = entry.indexOf('=');
            if (eq >= 0) {
                parameters[decodeURIComponent(entry.slice(0, eq))] = decodeURIComponent(entry.slice(eq + 1));
            }
        });

        // if variables was provided, try to format it.
        if (parameters.variables) {
            try {
                parameters.variables = JSON.stringify(JSON.parse(parameters.variables), null, 2);
            } catch (e) {
                // Do nothing, we want to display the invalid JSON as a string, rather
                // than present an error.
            }
        }

        _this.state = {
            token: '',
            parameters: parameters
        };
        return _this;
    }

    _createClass(CustomGraphiQL, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                { style: containerStyle },
                _react2.default.createElement(_tokenInput.TokenInput, { onChange: this.handleTokenInputChange }),
                _react2.default.createElement(_graphiql2.default, { fetcher: this.graphQLFetcher,
                    query: this.state.parameters.query,
                    variables: this.state.parameters.variables,
                    operationName: this.state.parameters.operationName,
                    onEditQuery: this.handleEditQuery,
                    onEditVariables: this.handleEditVariables,
                    onEditOperationName: this.handleEditOperationName })
            );
        }
    }, {
        key: 'handleTokenInputChange',
        value: function handleTokenInputChange(newTokenValue) {
            this.setState(function (prevState) {
                return Object.assign({}, prevState, {
                    token: newTokenValue
                });
            });
        }
    }, {
        key: 'graphQLFetcher',
        value: function graphQLFetcher(graphQLParams) {
            var headers = {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            };

            if (this.state && this.state.token) {
                Object.assign(headers, {
                    'Authorization': 'Bearer ' + this.state.token
                });
            }

            return (0, _isomorphicFetch2.default)(this.props.graphQLEndpoint, {
                method: 'post',
                headers: headers,
                credentials: 'include',
                body: JSON.stringify(graphQLParams)
            }).then(function (response) {
                return response.text();
            }).then(function (responseBody) {
                try {
                    return JSON.parse(responseBody);
                } catch (error) {
                    return responseBody;
                }
            });
        }
    }, {
        key: 'handleEditQuery',
        value: function handleEditQuery(newQuery) {
            var changeParameters = { parameters: { query: newQuery } };
            this.setState(function (prevState) {
                return Object.assign({}, prevState, changeParameters);
            });
            this.updateURL();
        }
    }, {
        key: 'handleEditVariables',
        value: function handleEditVariables(newVariables) {
            var changeParameters = { parameters: { variables: newVariables } };
            this.setState(function (prevState) {
                return Object.assign({}, prevState, changeParameters);
            });
            this.updateURL();
        }
    }, {
        key: 'handleEditOperationName',
        value: function handleEditOperationName(newOperationName) {
            var changeParameters = { parameters: { operationName: newOperationName } };
            this.setState(function (prevState) {
                return Object.assign({}, prevState, changeParameters);
            });
            this.updateURL();
        }
    }, {
        key: 'updateURL',
        value: function updateURL() {
            var _this2 = this;

            var newSearch = '?' + Object.keys(this.state.parameters).filter(function (key) {
                return Boolean(_this2.state.parameters[key]);
            }).map(function (key) {
                return encodeURIComponent(key) + '=' + encodeURIComponent(_this2.state.parameters[key]);
            }).join('&');
            history.replaceState(null, null, newSearch);
        }
    }]);

    return CustomGraphiQL;
}(_react.Component);

var containerStyle = {
    height: "100%"
};