'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = renderGraphiQLPage;

var _require = require('../../package.json'),
    version = _require.version;

function renderGraphiQLPage(options) {
  var graphQLEndpoint = options.graphQLEndpoint;

  return '\n<!DOCTYPE html>\n   <html>\n     <head>\n       <style>\n         body {\n           height: 100%;\n           margin: 0;\n           width: 100%;\n           overflow: hidden;\n         }\n         #graphiql {\n           height: 100vh;\n         }\n       </style>\n       <link href="//unpkg.com/graphiql@0.11.2/graphiql.css" rel="stylesheet" />\n       <script src="//cdn.jsdelivr.net/fetch/2.0.1/fetch.min.js"></script>\n       <script src="//cdnjs.cloudflare.com/ajax/libs/react/15.6.1/react.js" integrity="sha256-1uk/AXiYWDJQQgWL10P3Vz5qhIsyBxnwo4dwmw4cYHc=" crossorigin="anonymous"></script>\n       <script src="//cdnjs.cloudflare.com/ajax/libs/react/15.6.1/react-dom.js" integrity="sha256-DgeuoVzoa2SXxU85mfFSVK8FX3l7FxCoBn5uO3v1jYI=" crossorigin="anonymous"></script>\n       <script src="//cdn.jsdelivr.net/npm/@agilys/custom-graphiql@' + version + '/graphiql.min.js"></script>\n     </head>\n     <body>\n       <div id="graphiql">Loading...</div>\n       <script type="text/javascript">\n          CustomGraphiQL.init(document.getElementById(\'graphiql\'), { graphQLEndpoint : \'' + graphQLEndpoint + '\' });        \n       </script>\n     </body>\n   </html>   \n  ';
}